/*
   Questo programma fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


/* COLORI: stampa caratteri colorati nelle varie possibili combinazioni */


#include "Jconio.c"     /*usa la libreria di console Jackson*/
#include <stdio.h>      /*necessario per la sprintf*/


main()
{
    int  f,b;           /*colori di foreground, background*/
    char s[80];         /*buffer per stampe <1>*/
    int  c;

    Jtextback(LIGHTGRAY);                           /*fondo bianco <2>*/
    Jclrscr();                                      /*cancella video <3>*/

    for (b = 0; b < 8; b++) {                       /*per ogni sfondo*/
        Jtextback(b);                               /*lo sceglie*/
        for (f = 0; f < 16; f++) {                  /*per ogni colore*/
            Jtextcolor(f);                          /*lo sceglie*/
            sprintf(s,"%2d su %2d ",f,b);           /*prepara stringa <4>*/
            Jgotoxy(b*10+2,f+2);                    /*si posiziona <5>*/
            Jputs(s);                               /*e la stampa*/
        }
    }

    Jtextcolor(YELLOW+BLINK);                       /*giallo lampegg. <6>*/
    Jtextback(BLACK);                               /*su fondo nero*/
    Jgotoxy(2,20);
    Jputs(" Aggiungendo BLINK si ottengono"         /*<7>*/
          " caratteri lampeggianti. \r\n\r\n\r\n");

    Jtextcolor(LIGHTGRAY);                          /*rimette al bianco*/
    Jgotoxy(Jposx()+1,Jposy());                     /*avanza di uno <8>*/

    Jputs(" Premi Return per continuare:   ");
    Jgotoxy(Jposx()-2,Jposy());                     /*retrocede di 2*/
    while ( (c = getchar()) != EOF && c != '\n')    /*aspetta Return <9>*/
        ;
    Jclrscr();                                      /*cancella al nero*/
}

/*  Note su main:
    <1> Dato che la libreria di console Jackson non comprende una Jprintf,
        occorre stampare in un array di char (buffer) con la sprintf, e poi
        stampare la stringa su video con la Jputs.
    <2> Ci sono solo 8 colori di fondo, che vanno da 0 a 7, cio da BLACK a
        LIGHTGRAY. Quest'ultimo  il grigio chiaro, cio il bianco non
        intensificato, ed  l'unico bianco usabile per il fondo.
    <3> Il video viene cancellato al colore di fondo corrente (LIGHTGRAY).
    <4> Stampa con la sprintf nell'array s[], invece che direttamente su
        video (vedi nota 1).
    <5> Aggiunge 1 alla posizione calcolata (sia in orizzontale che in
        verticale) perch le coordinate delle caselle video iniziano da 1 e
        non da zero; aggiunge ancora 1 per lasciare un bordo di un carattere
        a sinistra e sopra le scritte.
    <6> Per ottenere caratteri lampeggianti, si aggiunge la costante BLINK
        al colore desiderato. Notare che il valore di BLINK  diverso a
        seconda del compilatore usato (per la cronaca, 128 per il Turbo C e
        16 per il Quick C), ma il programmatore pu (e deve) ignorare questo
        problema ed usare la costante BLINK invece che un numero.
    <7> Per andare a capo con la libreria di console non basta un newline \n,
        ma occorre scrivere esplicitamente un CRLF: \r\n.
    <8> Per avanzare il cursore di un carattere senza scrivere sul video,
        basta leggere la posizione corrente con Jposx e Jposy, e poi
        cambiare posizione con Jgotoxy aggiungendo 1 alla x corrente. Questa
        tecnica viene nuovamente usata due linee dopo per indietreggiare di
        due caratteri in modo da lasciar vedere il cursore su fondo nero.
    <9> Il problema di aspettare un Return con la getchar  trattato nella
        lezione B4. La lezione E2 introdurr le funzioni di input della
        libreria di console Jackson, che sono di uso molto pi pratico.
*/
