/*
   Questo programma fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


/* INVENTA: gli autori di alcune celebri invenzioni */


#include <stdio.h>

main()
{
    int n;      /*numero scelto*/

    printf("\nChi invent:\n\n"                     /*titolo e prompt <1>*/
           " 1) Il primo cannocchiale di uso pratico\n"
           " 2) La penna a sfera\n"
           " 3) La prima lampadina affidabile\n"
           " 4) Il telefono\n"
           " 5) Il fonografo, antenato del giradischi\n"
           " 6) La radio\n"
           " 7) Il linguaggio C\n\n"
           "Scegli (1-7): ");
    scanf("%d",&n);                                 /*input scelta*/
    printf("\n");                                   /*va a capo <2>*/

    switch(n) {                                     /*sceglie <3>*/
    case 1:                                         /*primo caso <4>*/
        printf("Galileo Galilei, perfezionando studi precedenti.\n");
        break;                                      /*fine primo caso <5>*/
    case 2:
        printf("L'ungherese Laszlo Biro, che le diede anche il nome.\n");
        break;
    case 3:                                         /*due casi <6>*/
    case 5:
        printf("Thomas Alva Edison, il poliedrico inventore statunitense.\n");
        break;
    case 4:
        printf("Antonio Meucci (perfezionato in seguito da G.Bell).\n");
        break;
    case 6:
        printf("Guglielmo Marconi, che continu poi le"
               " ricerche in Inghilterra.\n");
        break;
    case 7:
        printf("Dennis Ritchie, nei Bell Laboratories della AT&T.\n");
        break;
    default:                                        /*nessun caso <7>*/
        printf("Questa non  una scelta valida.\n");
        break;
    }
}

/*  Note:
    <1> Una stringa in C non ha limiti di lunghezza, e pu contenere quanti
        newline (\n) si desiderano, per cui pu essere usata per contenere
        l'intero menu di scelta. Per migliore leggibilit  stata interrotta
        (chiudendo e riaprendo le virgolette) nei punti corrispondenti agli
        a capo nella stampa. Queste interruzioni NON ci sono nella stringa,
        che rimane una sola. Gli a capo nella stampa sono causati dai \n.
    <2> Questo a capo  semplicemente una comodit per non doverlo fare
        pi avanti, all'inizio di ciascuna risposta da stampare.
    <3> La scelta avviene in base al valore della variabile indicata (n).
    <4> Le istruzioni che seguono case 1: sono eseguite solo n vale 1.
    <5> Bisogna terminare ogni case con break, altrimenti l'esecuzione
        prosegue diritta con le istruzioni del case successivo.
    <6> Le istruzioni che seguono sono eseguite in due casi: se n vale 3
        e se n vale 5.
    <7> Le istruzioni che seguono default: sono eseguite solamente se non
         stata eseguita nessuna delle scelte precedenti. Sarebbe utile
        ripetere l'input in caso di errore, ma le istruzioni per farlo
        non sono ancora state introdotte (lo saranno nella lezione B4).
*/
