/*
   Questo programma fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


/* SECONDI: giorni, ore, minuti, secondi in secondi */


#include <stdio.h>

main()
{
    long giorni;                        /*dati in input <1>*/
    long ore;
    long minuti;
    long secondi;
    long sec;                           /*secondi risultanti*/
    int  n;                             /*numero di dati introdotti*/

    const int secminuto = 60;           /*costanti per la conversione <2>*/
    const int minutiora = 60;
    const int oregiorno = 24;
    const long secora = secminuto*minutiora;    /*costanti calcolate*/
    const long secgiorno = secora*oregiorno;

    printf("\n Conversione da unit di tempo a secondi:\n\n");
    printf("Giorni, ore, minuti, secondi: ");       /*prompt*/
    n = scanf("%ld,%ld,%ld,%ld",
          &giorni,&ore,&minuti,&secondi);           /*input dati <3>*/

    if (n < 4) {                                    /*controlla i dati <4>*/
        printf("\n- Hai introdotto solo %d"
               " dei 4 dati richiesti.\n",n);
    } else {                                        /*tutto ok, calcola <5>*/
        sec = secondi;                              /*inizia con i secondi*/
        sec += (minuti*secminuto);                  /*aggiunge i minuti*/
        sec += (ore*secora);                        /*le ore*/
        sec += (giorni*secgiorno);                  /*ed i giorni*/

        printf("\n%ld giorni, %ld ore, %ld minuti"
               " e %ld secondi = %ld secondi\n",
               giorni,ore,minuti,secondi,sec);
    }
}

/*  Note:
    <1> Tutti i dati sono long, per evitare problemi. Meglio rallentare
        i calcoli, piuttosto che avere risultati errati se l'utente
        introduce valori troppo grandi.
    <2> Sono le stesse usate nel programma TEMPO.
    <3> Essendo tutte variabili long, si usa %ld. La scanf restituisce il
        numero di dati che  riuscita a leggere correttamente.
    <4> E' importante verificare la validit dei dati, e come minimo la
        corretta introduzione di tutti i dati richiesti. In caso di errore
        sarebbe il caso di richiedere nuovamente l'input dei dati, ma non
        abbiamo ancora introdotto le istruzioni che consentono di farlo.
    <5> Questo blocco viene eseguito solo se  stato introdotto il numero
        corretto di dati, cio 4.
*/

