/*
   Questo programma fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


/* CHARSET: stampa il set dei caratteri ASCII standard <1> */


#include <stdio.h>

main()
{
    const int ncol = 6;                             /*numero colonne*/
    const int nrig = 16;                            /*numero righe*/

    int r,c,k;

    printf("\n Caratteri ASCII standard:\n\n");

    for (c = 0; c < 6; c++) {                       /*intestazioni*/
        printf("Car  Cod.    ");
    }
    printf("\n\n");

    for (r = 0; r < nrig; r++) {                    /*stampa per righe*/
        k = ' '+r;                                  /*primo codice riga <2>*/
        for (c = 0; c < ncol; c++) {                /*e per colonne*/
            printf(" %c   %-8d",k,k);               /*stampa carattere <3>*/
            k += nrig;                              /*codice prox colonna*/
        }
        putchar('\n');                              /*fine riga <4>*/
    }
}

/*  Note:
    <1> Il set ASCII standard non comprende le lettere accentate, che
        nei PC IBM e compatibili hanno codice maggiore di 127. Il carattere
        con codice 127 non fa teoricamente parte dei caratteri stampabili,
        ma qui viene ugualmente mostrato il suo simbolo nel PC IBM.
    <2> ' '  32, cio il codice ASCII dello spazio, il primo carattere
        stampabile (i caratteri con codice 0-31 sono caratteri di controllo).
        Man mano aumenta r, cio la posizione nella riga, aumenta anche il
        codice del carattere da stampare.
    <3> Il codice k  stampato due volte, prima come carattere corrispondente
        (%c), poi come numero decimale allineato a sinistra (%-8d).
    <4> Per andare a capo basta stampare un newline con la putchar, che nel
        caso di un singolo carattere  molto pi efficiente della printf.
*/
