/*
   Questo programma fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


/* INFOGRAF: informa sul modo grafico scelto dalla Jinitgraph */


#include <stdio.h>

#include "Jgraph.h"     /*header della libreria grafica <1>*/


/********************************************************************
 * main
 ********************************************************************/

main()
{
    int x,y,c,ok;

    if (Jinitgraph() == 0) {                        /*inizializza grafica*/
        puts("\n- Non sono in grado di usare"
             " la grafica di questo computer.");
    } else {                                        /*se ci riesce*/
        x = Jgetdimx();                             /*legge dati <2>*/
        y = Jgetdimy();
        c = Jgetcolors();
        Jclosegraph();                              /*torna in modo testo*/

        printf("\n\n\nLa Jinitgraph rileva un modo grafico\n"
               "da %d x %d pixel con %d colori.\n\n"
               "Si tratta quindi presumibilmente\n"
               "di una scheda ",x,y,c);

        if (y == 480) {                             /*indovina scheda <3>*/
            puts("VGA.");
        } else if (y == 400) {
            puts("Olivetti.");                      /*<4>*/
        } else if (y == 350) {
            puts("EGA.");
        } else if (y == 348) {
            puts("Hercules.");
        } else if (y == 200) {
            puts("CGA.");
        } else {
            puts("a me ignota.");
        }
    }
}

/*  Note su main:
    <1> Questo modulo va linkato con JGRAPH.OBJ.
    <2> Ricorda questi dati nelle variabili, perch non saranno pi
        accessibili una volta usciti dal modo grafico.
    <3> Tutte le schede citate vengono inizializzate nel modo a maggiore
        risoluzione, cio tipicamente con 640 pixel in orizzontale.
        Distinguiamo il tipo di scheda in base alla risoluzione verticale.
    <4> I modi Olivetti non vengono riconosciuti se il programma 
        compilato col Turbo C 2.0, come nel caso della versione eseguibile
        fornita sul dischetto.
*/
