/*
   Questo file fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


/* FINUTIL.H: dichiarazioni necessarie per usare FINUTIL dall'esterno <1> */


/*********************************************************************
 * ApreFinestra: crea una nuova finestra con area interna x1,y1,x2,y2,
 *               ritorna il numero della finestra creata, zero se non
 *               la pu creare (non c' memoria,  finito lo stack
 *               delle finestre aperte, o gli argomenti sono errati).
 ********************************************************************/

int  ApreFinestra(int x1, int y1, int x2, int y2);


/*********************************************************************
 * ChiudeFinestra: chiude l'ultima finestra aperta, ritorna numero
 *                 finestra corrente, zero se non ci sono fin. aperte.
 ********************************************************************/

int  ChiudeFinestra(void);


/*********************************************************************
 * Wputs: scrive la stringa s nella finestra corrente, a partire dalla
 *        posizione corrente (l'ultima stampata). Ogni \n nella
 *        stringa manda a capo nella finestra. I caratteri che escono
 *        dai bordi della finestra non sono stampati.
 ********************************************************************/

void Wputs(char *s);


/* Note su FINUTIL.H:
    <1> Questo file contiene tutte le informazioni necessarie ad un utente
        del modulo FINUTIL, in modo che questo possa essere usato senza
        conoscerne i dettagli: il codice potrebbe anche essere fornito gi
        compilato in un file FINUTIL.OBJ, con allegato questo header.
        Tutte le variabili usate solo da FINUTIL sono locali al file stesso:
        non ci sono variabili globali.
*/
