/*
   Questo programma fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


// ORARIO.CPP: suona un segnale orario usando la classe Timer


#include "c-timer.h"      //<1>

#include <iostream.h>


main()
{
    cout << '\n';                                   //a capo

    Timer t;                                        //crea un Timer <2>
    for (int i = 0; i < 4; i++) {                   //per 4 volte <3>
        cout << ".\a";                              //d un segnale <4>
        t.Sincro(1.0);                              //aspetta <5>
    }

    cout << "\a\a  ora di imparare il C++!\n";     //altro segnale <6>
}

/* Note su ORARIO:
    <1> Per usare la classe Timer occorre includerne l'interfaccia, cio
        lo header "c-timer.h". La "c-" iniziale  una nostra convenzione
        per indicare che si tratta di una classe. Il codice oggetto ottenuto
        compilando questo programma va linkato con quello di "c-timer.cpp".
    <2> L'oggetto t  un esemplare della classe Timer. Il vantaggio di
        usare una classe invece di una libreria sta nella semplificazione:
        non occorre tenere una variabile per ricordare il tempo corrente,
        e quindi non occorre sapere come si fa a misurare il tempo (infatti
        questo programma non include <time.h>). Inoltre, si potrebbero fare
        tante operazioni (es. sincronizzazioni) indipendenti, semplicemente
        dichiarando pi variabili della classe Timer. Il riferimento per
        eventuali sincronizzazioni viene preso all'istante di creazione
        dell'oggetto (dal costruttore della classe Timer). Si risparmiano
        quindi anche le inizializzazioni.
    <3> Una variabile pu essere dichiarata quando fa comodo, come  il
        caso della variabile di controllo (i) di questo ciclo for.
    <4> Stampa un punto e suona un segnale acustico.
    <5> Aspetta 1 secondo (circa) dall'ultima chiamata alla Sincro, oppure
        dalla creazione dell'oggetto t (se  la prima chiamata). Passando
        un double si richiede un tempo in secondi, passando un int lo si
        richiede in tick (la classe Timer contiene due funzioni Sincro
        sovrapposte).
    <5> Suona un segnale di durata doppia (due beep di seguito).
*/
