/*
   Questo programma fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


/* ARG: mostra gli argomenti passati al programma dal DOS */


#include <stdio.h>


main(int argc, char *argv[])    /*<1>*/
{
    int i;

    printf("argc = %d\n",argc);                     /*argc = num. argomenti*/
    for (i = 0; i < argc; i++) {
        printf("argv[%d] = \"%s\"\n",i,argv[i]);    /*argv[] = argomenti <2>*/
    }
}

/* Note:
    <1> argc  un int che contiene il numero degli argomenti passati al
        programma, argv[]  un array di pointer a char. Ciascuno degli
        elementi di argv ([0]..[argc-1]) punta ad una stringa contenente
        uno degli argomenti, nell'ordine in cui sono stati indicati sulla
        linea di comando del DOS. argv[0] punta al pathname completo del
        programma (solo dal DOS 3.0 in poi).
    <2> La combinazione \" consente di includere le virgolette all'interno
        di una stringa, senza terminare la stringa.
*/
