/*
   Questo programma fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


/* QUADRATO: calcola il quadrato di un numero intero */


#include <stdio.h>

main()
{
    int x;                      /*numero di cui calcolare il quadrato*/
    int quadx;                  /*quadrato del numero*/
    const int xmax = 181;       /*limite superiore valido <1>*/

    printf("\n Calcolo del quadrato dell'intero x:\n\n");
    printf("x = ");                                     /*prompt*/
    scanf("%d",&x);                                     /*input valore*/

    if (x <= xmax) {                                    /*scelta <2>*/
        quadx = x*x;                                    /*calcola quadrato*/
        printf("\nIl quadrato di %d  %d.\n",x,quadx);  /*e lo stampa*/
    } else {                                            /*alternativa <3>*/
        printf("\n- x non pu superare %d.\n",xmax);    /*avverte*/
    }
}

/*  Note:
    <1> Il quadrato di 181  32761, il quadrato del numero successivo (182)
         33124 ed  troppo grande per essere contenuto in un int.
    <2> Se il confronto risulta vero, esegue la prima istruzione che segue:
        questa  un'istruzione composta racchiusa tra parentesi graffe,
        che comprende in realt due istruzioni semplici.
    <3> Se il confronto risulta falso, esegue la prima istruzione dopo
        l'else. Essendo un'istruzione sola, le graffe non sarebbero
        necessarie, ma metterle non costa nulla ed evita possibili errori.
*/
