/*
   Questo programma fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


/* SFERA: calcola il volume di una sfera di raggio dato */


#include <stdio.h>

main()
{
    double r;                           /*raggio della sfera <1>*/
    double vol;                         /*volume della sfera*/
    const double pi = 3.1415926536;     /*pigreco <2>*/

    printf("\n Calcolo del volume di una sfera:\n\n");
    printf("Raggio della sfera: ");                     /*prompt*/
    scanf("%lf",&r);                                    /*input raggio <3>*/

    vol = (4.0/3.0)*pi*r*r*r;                           /*calcola volume <4>*/
    printf("Il volume della sfera di raggio"
           " %.3f  %.3f\n",r,vol);                     /*e lo stampa <5>*/
}

/*  Note:
    <1> Dovendo trattare valori reali (non interi) occorre fare ricorso a
        variabili in virgola mobile. Il tipo double offre un'elevata
        precisione (ed occupa pi spazio del tipo float, ma qui la cosa 
        trascurabile dato che ci sono pochissime variabili).
    <2> Una costante col punto decimale ma senza alcun suffisso  considerata
        double (col suffisso f sarebbe float, e col suffisso L long double).
    <3> Per l'input di un double si deve indicare %lf (elle minuscola!).
    <4> E' essenziale indicare 4.0/3.0. Scrivendo 4/3 sarebbe eseguita
        una divisione intera, con risultato zero! Inoltre sarebbe meglio
        calcolare la costante (4.0/3.0)*pi una volta per tutte, all'inizio.
        Le parentesi sono messe per chiarezza, ma non sono indispensabili
        dato che divisione e moltiplicazione hanno la stessa precedenza, e
        quindi sono eseguite da sinistra a destra. Anche qui, nel dubbio
        meglio una parentesi in pi che un rischio di errore.
    <5> Per motivi storici, per stampare un double si indica %f, che va bene
        anche per i float. Questi sono infatti convertiti a double nella
        chiamata alla printf. Notare la stampa con 3 decimali (%.3f), che
        approssima l'ultima cifra al valore corretto ma ha in questo caso
        l'inconveniente di mostrare come 0.000 i numeri molto piccoli.
*/
