/*
   Questo programma fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


/* TEMPO: converte secondi in giorni, ore, minuti, secondi */


#include <stdio.h>

main()
{
    long secondi;                       /*secondi da convertire <1>*/
    long sec;                           /*copia per la stampa*/
    int giorni;                         /*risultati della conversione <2>*/
    int ore;
    int minuti;
    const int secminuto = 60;           /*costanti per la conversione <3>*/
    const int minutiora = 60;
    const int oregiorno = 24;
    const long secora = secminuto*minutiora;    /*costanti calcolate <4>*/
    const long secgiorno = secora*oregiorno;

    printf("\n Calcolo delle unit di tempo:\n\n");
    printf("Secondi da convertire: ");              /*prompt*/
    scanf("%ld",&secondi);                          /*input valore <5>*/

    sec = secondi;                                  /*tiene una copia <6>*/

    giorni = secondi/secgiorno;                     /*calcola giorni <7>*/
    secondi -= (giorni*secgiorno);                  /*e sec. restanti <8>*/
    ore = secondi/secora;                           /*calcola ore*/
    secondi -= (ore*secora);                        /*e sec. restanti <9>*/
    minuti = secondi/secminuto;                     /*calcola minuti*/
    secondi -= (minuti*secminuto);                  /*e secondi restanti*/

    printf("\n\n%ld secondi = %d giorni, %d ore,"   /*stampa risultati*/
           " %d minuti e %ld secondi\n",
           sec,giorni,ore,minuti,secondi);
}

/*  Note:
    <1> I secondi sono conservati in una variabile di tipo long in modo
        che possano superare 32767.
    <2> Per i risultati bastano normali variabili di tipo int.
    <3> E' utile usare costanti e non introdurre numeri nel programma. Ne
        guadagnano la leggibilit e la facilit di modifica.
    <4> Queste costanti sono calcolate partendo dai valori delle costanti
        precedenti. Sono long per evitare possibili problemi nei calcoli
        (vedi nota 9).
    <5> Per effettuare l'input di un long con la scanf si deve indicare %ld.
    <6> Il valore della variabile secondi verr alterato nei calcoli. Questa
        copia serve per la stampa finale.
    <7> Una divisione tra due long d un long, che viene poi assegnato alla
        variabile giorni, che  un int. Questo non crea problemi, purch non
        vi sia overflow (cio un risultato maggiore di 32767). Si tratta
        comunque di una divisione intera con perdita del resto.
    <8> Lo stesso risultato si poteva avere con secondi%secgiorno, che d
        appunto il resto della divisione. Di solito per quest'ultima
        tecnica  leggermente pi lenta in quanto implica una divisione.
        L'operatore -= toglie da secondi il valore dell'espressione a destra.
    <9> Se secora fosse stato un int, la moltiplicazione ore*secora avrebbe
        potuto dare overflow, causando un risultato errato. La conversione
        a long per l'assegnazione alla variabile secondi avviene infatti
        dopo l'esecuzione della moltiplicazione. Moltiplicando invece un
        int (ore) per un long (secora), il risultato  un long corretto.
        Nel dubbio, meglio usare variabili long ed evitare problemi (pagando
        il prezzo di un leggero rallentamento).
*/
