/*
   Questo file fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


/* GRAFUTIL.H: dichiarazioni per usare GRAFUTIL dall'esterno */


/********************************************************************
 * GsetUtilColor: sceglie il colore usato da tutte le funzioni di
 *                questo modulo.
 ********************************************************************/

void GsetUtilColor(int c);


/********************************************************************
 * GinputInt: input valore intero compreso tra mi e ma, senza
 *            default. Ritorna valore, o zero se solo Return.
 ********************************************************************/

int GinputInt(int mi, int ma);


/********************************************************************
 * GinputStringa: mostra campo di input con default, input
 *                controllato di stringa nell'array s[] non oltre
 *                lmax caratteri, accetta correzioni con backspace,
 *                mette zero finale, ritorna lunghezza della stringa
 *                introdotta, lascia il cursore dov'era.
 ********************************************************************/

int GinputStringa(char *s, int lmax);


/********************************************************************
 * Ggetkey: aspetta un carattere in modo grafico con cursore simulato
 *          con simbolo cs, lampeggiante.
 ********************************************************************/

int Ggetkey(int cs);


/********************************************************************
 * GclearEOL: cancella fino a fine linea, resta dov'era.
 ********************************************************************/

void GclearEOL(void);


/********************************************************************
 * GputsAt: stampa s alla posizione data.
 ********************************************************************/

void GputsAt(int x, int y, char *s);
