/*
   Questo file fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


// C-MESSAG: funzioni (metodi) della classe Messaggio


#include "c-messag.h"    //interfaccia della classe Messaggio

#include <conio.h>
#include <string.h>


/********************************************************************
 * Funzioni della classe Messaggio
 ********************************************************************/

// costruttore: scrive messaggio sul video alla posizione data.

Messaggio::Messaggio(int posx, int posy, char *mes) //<1>
{
    x = posx;                                       //registra posizione
    y = posy;
    n = strlen(mes);                                //e lunghezza

    gotoxy(x,y);
    cputs(mes);                                     //stampa messaggio
}

/* Note sul costruttore:
    <1> Il costruttore viene chiamato automaticamente quando si dichiara
        un oggetto della classe Messaggio (o lo si crea con new).
*/


// distruttore: cancella messaggio dal video ricoprendolo con spazi.

Messaggio::~Messaggio()
{
    char buf[81];

    memset(buf,' ',n);                              //prepara stringa spazi
    buf[n] = 0;

    gotoxy(x,y);                                    //la stampa
    cputs(buf);
}

/* Note sul distruttore:
    <1> Il distruttore viene chiamato automaticamente quando un oggetto della
        classe Messaggio esce dal suo campo di validit (o viene distrutto
        con delete, se  stato creato con new).
*/
