/*
   Questo file fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


// C-TIMER: funzioni (metodi) della classe Timer
//
// Questa  l'implementazione della classe Timer, che definisce le
// funzioni che non sono gi definite inline nell'interfaccia (C-TIMER.H).
// Il codice oggetto che si ottiene compilandola va linkato col resto
// del programma.


#include "c-timer.h"   //interfaccia della classe Timer


/********************************************************************
 * Funzioni della classe Timer
 ********************************************************************/

// Aspetta(int): attende il numero indicato di tick

void Timer::Aspetta(int tk)
{
    clock_t t = clock()+tk;
    while (clock() < t)
        ;
}

// Sincro(int): attende il numero indicato di tick dalla chiamata precedente

void Timer::Sincro(int tk)    
{
    clock_t t = t0+tk;                              //calcola tempo limite
    while (clock() < t)                             //e lo aspetta
        ;
    t0 = clock();                                   //per prossima volta
}
