/*
   Questo programma fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


// DUEDADI.CPP: tira due dadi usando la classe Random


#include "c-random.h"    //<1>

#include <iostream.h>


main()
{
    Random r;     //dichiara un oggetto della classe Random <2>

    int d1 = r.RandTra(1,6);                        //estrae due uscite <3>
    int d2 = r.RandTra(1,6);
    cout << "\nPrimo dado   :  " << d1              //mostra risultati <4>
         << "\nSecondo dado :  " << d2
         << "\nTotale       :  " << d1+d2 << '\n';
}

/* Note su DUEDADI:
    <1> Per usare la classe Random occorre includerne l'interfaccia, cio
        lo header "c-random.h". La "c-" iniziale  una nostra convenzione
        per indicare che si tratta di una classe. Il codice oggetto ottenuto
        compilando questo programma va linkato con quello di "c-random.cpp".
    <2> L'oggetto r  un esemplare della classe Random. Uno dei vantaggi
        rispetto all'uso di una libreria sta nell'inizializzazione automatica
        del generatore di numeri casuali: non occorre chiamare srand, ci
        pensa il costruttore della classe Random quando viene dichiarato
        il primo oggetto della classe stessa. Tra l'altro, il costruttore
        garantisce che srand non venga chiamata pi di una volta. Il concetto
         che non importa sapere come  fatta la classe Random: la si usa.
    <3> r.RandTra  la funzione RandTra dell'oggetto r (e quindi della classe
        Random), che estrae un numero compreso tra i due limiti dati. Una
        variabile, come d1, pu essere dichiarata in C++ in qualunque momento.
    <4> Gli operatori << possono essere concatenati per stampare pi valori,
        anche di tipo differente: qui ci sono stringhe, int, ed un carattere.
*/
